#include <os.h>
#include <stdint.h>
#include <fdlibm.h>
#include "nRayC.h"

int main(int argc, char *argv[])
{
	static int map[576] = {
						1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
						1, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 2, 0, 0, 0, 1,
						1, 0, 0, 2, 2, 2, 0, 2, 0, 2, 2, 2, 2, 0, 2, 0, 2, 2, 0, 2, 0, 2, 0, 1,
						1, 0, 0, 2, 4, 0, 0, 2, 0, 2, 0, 0, 0, 0, 2, 0, 0, 2, 0, 2, 0, 2, 5, 1,
						1, 0, 0, 3, 2, 2, 2, 2, 0, 3, 0, 2, 2, 2, 2, 2, 0, 2, 0, 0, 0, 2, 4, 1,
						1, 0, 0, 3, 0, 0, 0, 0, 0, 3, 3, 2, 0, 0, 0, 0, 0, 2, 3, 2, 2, 2, 2, 1,
						1, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 3, 0, 0, 0, 0, 0, 1,
						1, 0, 0, 2, 0, 0, 2, 2, 2, 2, 3, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 1,
						1, 0, 0, 0, 0, 0, 2, 2, 3, 3, 2, 2, 4, 0, 4, 0, 2, 2, 2, 2, 2, 2, 0, 1,
						1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 2, 0, 0, 2, 0, 0, 1,
						1, 3, 4, 0, 4, 2, 2, 0, 0, 0, 0, 0, 0, 0, 2, 2, 0, 3, 0, 0, 0, 0, 0, 1,
						1, 0, 0, 0, 0, 2, 2, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 3, 0, 2, 2, 3, 2, 1,
						1, 0, 0, 0, 0, 2, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 2, 2, 0, 2, 0, 0, 0, 1,
						1, 0, 0, 0, 0, 2, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 2, 0, 0, 0, 2, 0, 1,
						1, 0, 0, 0, 0, 2, 2, 0, 2, 2, 2, 2, 3, 2, 2, 2, 0, 2, 2, 2, 2, 2, 0, 1,
						1, 0, 0, 0, 0, 2, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1,
						1, 0, 0, 0, 0, 3, 0, 2, 2, 0, 2, 2, 3, 3, 3, 3, 3, 2, 0, 0, 0, 0, 0, 1,
						1, 0, 2, 2, 2, 3, 0, 2, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
						1, 0, 2, 0, 0, 2, 0, 2, 2, 2, 2, 0, 0, 2, 2, 2, 2, 2, 0, 0, 0, 2, 0, 1,
						1, 0, 3, 0, 2, 2, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 3, 2, 2, 0, 1,
						1, 0, 3, 0, 0, 0, 0, 2, 0, 2, 2, 2, 2, 2, 2, 2, 2, 0, 0, 0, 0, 0, 0, 4,
						1, 0, 3, 2, 3, 2, 0, 2, 0, 2, 0, 0, 0, 0, 0, 0, 2, 3, 3, 3, 2, 2, 2, 1,
						1, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4,
						1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
						};
	ScreenPoint mapDim = { 24, 24 };
	Vector dirVec = { 1.0, 0.0 }, planeVec = { 0.0, 0.66 }, player = { 1.2, 1.2 };
	float rotSpeed = 6, moveSpeed = 0.3;
	int plasmaPalette[256], x, y;
	char *screen, *plasmaBuffer, plasmaShift = 0, win = 0;
	
	uint16_t *textures;
	
	if(nRC_enableRelativePaths(argv))
	{
		printf("Couldn't change directory\n");
		exit(0);
	}
	
	screen = malloc(SCREEN_BYTES_SIZE);
	if(!screen) exit(0);
	
	plasmaBuffer = malloc(TEXTUREW * TEXTUREH * sizeof(char));
	if(!plasmaBuffer)
	{
		free(screen);
		exit(0);
	}
	
	textures = nRC_loadBMP("textures.bmp.tns");
	if(!textures)
	{
		free(screen);
		free(plasmaBuffer);
		exit(0);
	}
	
	for(x = 0; x < 256; x++)
	{
		plasmaPalette[x] = R5G6B5(
								(int)(sin(M_PI * x / 32.0) * 16 + 16),
								(int)(sin(M_PI * x / 64.0) * 32 + 32),
								(int)(sin(M_PI * x / 128.0) * 16 + 16)
								);
	}
	
	for(y = 0; y < TEXTUREH; y++)
	{
		for(x = 0; x < TEXTUREW; x++)
		{
			plasmaBuffer[y * TEXTUREW + x] = (int)(
						128.0 + (128.0 * sin(x / 16.0))
					+	128.0 + (128.0 * sin(y / 8.0))
					+	128.0 + (128.0 * sin(sqrt((x - 160) * (x - 160) + (y - 120) * (y - 120)) / 16.0))
					+	128.0 + (128.0 * sin(sqrt(x * y) / 8.0))
					) / 4;
		}
	}
	
	nRC_clearBuf(screen, 1);
	
	while(!(isKeyPressed(KEY_NSPIRE_ESC) || win))
	{
		nRC_rayCasting(map, player, mapDim, dirVec, planeVec, textures, screen);
		nRC_dispBuf(screen);
		nRC_clearBuf(screen, 1);
		
		if(isKeyPressed(KEY_NSPIRE_UP))
		{
			nRC_moveForward(&player, &dirVec, moveSpeed, map, mapDim);
		}
		else if(isKeyPressed(KEY_NSPIRE_DOWN))
		{
			nRC_moveBackward(&player, &dirVec, moveSpeed, map, mapDim);
		}
		
		if(isKeyPressed(KEY_NSPIRE_LEFT))
		{
			nRC_lookLeft(&dirVec, &planeVec, rotSpeed);
		}
		if(isKeyPressed(KEY_NSPIRE_RIGHT))
		{
			nRC_lookRight(&dirVec, &planeVec, rotSpeed);
		}
		
		if(getTileFront(player, dirVec, moveSpeed, map, mapDim) == 5 || getTileBehind(player, dirVec, moveSpeed, map, mapDim) == 5) win = 1;
		
		for(y = 0; y < TEXTUREH; y++)
		{
			for(x = 0; x < TEXTUREW; x++)
			{
				textures[TEXTUREW * TEXTUREH * 4 + y * TEXTUREW + x] = plasmaPalette[(plasmaBuffer[y * TEXTUREW + x] + plasmaShift) % 256];
			}
		}
		
		plasmaShift += 6;
	}
	
	free(plasmaBuffer);
	free(textures);
	free(screen);
	return 0;
}
